import { type InjectionKey, type Ref } from 'vue'
import { type Props as TabProps } from '~/components/ui/Tab.vue'

export const TABS_INJECTION_KEY = Symbol('tabs') as InjectionKey<{
  tabs: TabProps[]
  currentTitle: Ref<TabProps['title']>
}>

export interface PopoverContext {
  items: Ref<number>
  hoveredItem: Ref<number>
}

export const POPOVER_INJECTION_KEY = Symbol('popover') as InjectionKey<Ref<boolean>[]>
export const POPOVER_CONTEXT_INJECTION_KEY = Symbol('popover context') as InjectionKey<PopoverContext>
